#include "const.h"

/* 
	Voici une version modifie de la routine FastDrawLine de Extgraph
  qui la rend clippe et qui ne dessine qu'en mode A_NORMAL
   
	Attention, si le point 1 est hors de l'cran, rien n'est dessin
	Il faut faire un test avant et inverser les points si ncessaire
	(ce qui est fait dans draw_wire_object)																  */


/*---------------------------------------------------------------------------*/
/* speedy pixel access routines                                              */
/*---------------------------------------------------------------------------*/
#define PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define PIXADDR(p,x,y)  (((unsigned char*)(p))+PIXOFFSET(x,y))
#define PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))

#define SETPIX(a,m)   (*(a) |= (m)) // uses precalculated values now
#define CLRPIX(a,m)   (*(a) &= ~(m))
#define XORPIX(a,m)   (*(a) ^= (m))
#define PIXUP(a)      ((a)-=30)
#define PIXDOWN(a)    ((a)+=30)
#define PIXLEFT(a,m)   asm("rol.b  #1,%0;bcc.s  0f;subq.l #1,%1;0:"\
                          : "=d" (m), "=g" (a) : "0" (m), "1" (a))
#define PIXRIGHT(a,m)  asm("ror.b  #1,%0;bcc.s  0f;addq.l #1,%1;0:"\
                          : "=d" (m), "=g" (a) : "0" (m), "1" (a))


/*---------------------------------------------------------------------------*/
/* useful macros                                                             */
/*---------------------------------------------------------------------------*/
#define ABS(a)          (((a)<0) ? -(a): (a))
#define SPECIAL_SGN(a)  (((a)<0) ? 0 : 1)


/*===========================================================================*/
/* draws a line from (x1,y1) to (x2,y2) in given plane, with clipping        */
/*===========================================================================*/
void FastDrawLineClip(unsigned char* plane,
                  		short x1,short y1,
                  		short x2,short y2)
{
    short d,x,y,ax,ay,sx,sy,dx,dy;

    unsigned char *pixaddr;
    unsigned char pixmask;

    dx = x2 - x1;
    ax = ABS(dx)<<1;
    sx = SPECIAL_SGN(dx);

    dy = y2 - y1;
    ay = ABS(dy)<<1;
    sy = SPECIAL_SGN(dy);

    x = x1;
    y = y1;

    pixaddr=PIXADDR(plane, x, y);
    pixmask=PIXMASK(x);

        if (ax>ay) 
        		{           /* x dominant */
            d = ay - (ax>>1);
            do 
            	{
              if (x==-1 || x==LCD_WIDTH || y==-1 || y==LCD_HEIGHT) return;
              SETPIX(pixaddr,pixmask);
              if (x==x2) return;
              if (d>=0) 
              	{
                if(sy) 
                 	{
                  PIXDOWN(pixaddr);
                  y++;
                  }
                else
                  {
                  PIXUP(pixaddr);
                  y--;
                  }
                  d -= ax;
                }
                if (sx) 
                	{
                  PIXRIGHT(pixaddr, pixmask);
                  x++;
                	}
                else 
                	{
                	PIXLEFT(pixaddr, pixmask);
                  x--;
                	}
                d += ay;
            	} while(1);
        		}
        	else 
        		{                 /* y dominant */
            d = ax - (ay>>1);
            do 
            	{
              if (x==-1 || x==LCD_WIDTH || y==-1 || y==LCD_HEIGHT) return;
              SETPIX(pixaddr,pixmask);
              if (y==y2) return;
              if (d>=0) 
              	{
                if (sx) 
                 	{
                 	PIXRIGHT(pixaddr, pixmask);
                 	x++;
                 	}
                else
                  {
                  PIXLEFT(pixaddr, pixmask);
                  x--;
                  }
                  d -= ay;
                }
                if (sy) 
                	{
                  PIXDOWN(pixaddr);
                  y++;
                	}
                else 
                	{
                  PIXUP(pixaddr);
                  y--;
                	}
                d += ax;
            	} while(1);
        		}
}