// C Source File
// Created 24/08/2002; 17:11:23
// copyright 2002 Thibaut Chevalier

/************************************************************
 Space Dementia version 0.80 source (franais)
 pour la TI89, la TI92+ et V200
 programm par Thibaut Chevalier avec l'aide de David Coz
 moitib_calliope@hotmail.com
 http://moitib.free.fr/
 
 Cette source est distribue gratuitement.
 Vous n'etes pas authoriss a publier des versions modifies
 de Space Dementia sans mon accord. Vous pouvez en revanche en 
 utiliser des parties pour vos programmes.
 Merci de mentionner mon nom dans ce cas.
 Le codage n'est pas forcement exemplaire, mais je pense
 qu'il est correctement comment.
************************************************************/
 



#include "main.h"

void _main(void)
{
	short ship;
	
	/* Calcul des coefs de taille  la manire de SolidWorks
	short i, j;
	unsigned long l;
	extern Vertex* (shipVertices[]);
	extern short* (shipEnds[]);
	for (ship=0; ship < 10; ship++)
		{
		l = 0;
		i = 1;
		for (j = 1;j <= 8;j++)	
			{
			if (i > shipEnds[ship][0]) i--;
			l += (square(shipVertices[ship][shipEnds[ship][i]].x) + square(shipVertices[ship][shipEnds[ship][i]].y) + square(shipVertices[ship][shipEnds[ship][i]].z)); 
			i++;
			}
			
//	printf_xy(0,0,"%.1f",(int) l );
		l=l>>8;
		l=l*3;
		l=l>>2;
		ClrScr();
  	printf_xy(0, 0, "%d", (int)l); // la vraie valeur a prendre est la valeur affiche divide par 10 + 0.1

  	ngetchx();
  	}
	*/
	
	
	if (!(Vscreen = malloc(3*LCD_SIZE/2))) // Alloue de l'espace pour l'cran virtuel
		{		 // Si pas assez d'espace disponible (erreur dans malloc)...
		DlgMessage("Out of memory !", "Free some memory before running the program.", BT_NONE, BT_OK);
		return;
		}
	
	alloc_arrays(); // Initialisation des lements des tableaux qui contiennent les informations sur les vaisseaux
	randomize(); // initialise le gnrateur de nombre alatoires
	disable_timer();
	
	FontSetSys(F_4x6);
	ST_showHelp("Searching for .SHIP files...");	// afficher le message dans la status bar
	
	PortSet(Vscreen, 237, 127); // Redirige les fonctions graphiques vers l'cran virtuel
	
/************************* Etablissement de la liste des fichiers externes "vaisseaux"************************/
				
	FolderOp (NULL, FOP_ALL_FOLDERS | FOP_LOCK); // locker l'ensemble des fichiers de la calc (explication, voir l'aide sur SymFindFirst)
	
	SYM_ENTRY *symPtr;
	unsigned char* start;
	unsigned char* tmp;
	
	char name[9];
	char folder[9];
	char fullName[18];
	
	nbExtShip = 0;
	symPtr = SymFindFirst (NULL, FO_RECURSE);
  while (symPtr)
  	{
  	if (symPtr->handle)
  		{
			start = HeapDeref(symPtr->handle);
			if (start) 
			  {
				tmp = start + *(unsigned short*)(start) + 1;
				// contrle l'extension OTH-Type et 'SHIP', puis le code
        if (*tmp     == 0xF8 &&
          	*(tmp-5) == 'S'  &&
          	*(tmp-4) == 'H'  &&
          	*(tmp-3) == 'I'  &&
          	*(tmp-2) == 'P'  &&
          	*(unsigned short*)(start+2) == CODE_SHIP)
         	{
  				strncpy(folder, SymFindFolderName(), 8);	// enregistre le nom du dossier courant
  				strncpy(name, symPtr->name, 8); // enregistre le nom du fichier courant
					name[8]   = 0;
					folder[8] = 0;
  				sprintf(fullName, "%s\\%s", folder, name);                  
					if (!(ptrNames = realloc(ptrNames, 18 * (++nbExtShip)))) exit_proc(MEM_ERROR);
					strcpy(ptrNames + 18 * (nbExtShip - 1), fullName);
          }
				}
			}
  	symPtr = SymFindNext();	
		}
		
	FolderOp (NULL, FOP_ALL_FOLDERS | FOP_UNLOCK); // unlocker l'ensemble des fichiers de la calc
		
/***************************************************************************************************************/
	
	open_hsc();	// cre ou ouvre le fichier highscores & prefrences
	
	FontSetSys(F_4x6);
	
	for (ship = 0; ship <= 1; ship++) 
		INIT_TIE;  // initialisation des deux premiers vaisseaux
	
	run_menu(MAIN_MENU_ID); // demarrer le menu principal
	exit_proc(0); // cette fonction est xecute si ESC est press depuis le menu principal : cela veut dire : quitter le programme
	
} // fin de la fonction main
	
	
	
/************************************************************************************************************************/
	
void enable_timer(void)
{
	SetIntVec (AUTO_INT_1, save_int_1);		// rtablit l'interruption 1
}
 
void disable_timer(void)
{	
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // redirect auto-int 1 to "nothing"
}	
	
void free_sure(void* ptr)
{
	if (ptr != NULL) free(ptr);
}


void exit_proc(short err)
{
  free_arrays();			 // Libre les tableaux contenant les donnes pour les vaisseaux externes
  free_sure(ptrNames); // Libre l'espace allou pour stocker les noms des variables SHIP de la calc
	free_sure(Vscreen);  // Libre l'espace allou pour l'cran virtuel
	PortRestore();
 	close_hsc();				 // Remplir le fichier Highscores
 	enable_timer();
  if (err) DlgMessage("Out of memory !", "Free some memory before running the program.", BT_NONE, BT_OK);	// si manque de mmoire
  exit(0);
}






/*

FolderOp (NULL, FOP_ALL_FOLDERS | FOP_LOCK); // locker l'ensemble des fichiers de la calc (explication, voir l'aide sur SymFindFirst)
	
	SYM_ENTRY *SymPtr;
	char name[9];
	char folder[9];
	char fullName[18];
	FILE *fp1;
	short code, i;
	char extBuf[5];
	
	nbExtShip = 0;
	SymPtr = SymFindFirst (NULL, FO_RECURSE);
	while (SymPtr)
		{
  	if (SymPtr->flags.bits.folder != 1) // si la "variable" trouve n'est pas un dossier :
  		{
  		strcpy(folder, SymFindFolderName());	// enregistre le nom du dossier courant
  		strcpy(name, SymPtr->name); // enregistre le nom du fichier courant
  		sprintf(fullName, "%s\\%s\0x00", folder, name);
  		
  		fp1 = fopen(fullName,"rb");
  		fread(&code,sizeof(code),1,fp1);
  		fseek(fp1, -6, SEEK_END); // avancer jusqu'a la fin du fichier
  		fread(extBuf, 4, 1, fp1);	// lit l'extension
  		extBuf[4] = '\0';
  		if ((code == CODE_SHIP) && !strcmp("SHIP", extBuf))
 				{
				ClrScr();
  			DrawStr(0, 0, extBuf, A_REPLACE);
  			DrawStr(0, 10, fullName, A_REPLACE);
  			ngetchx();
				ptrNames = realloc(ptrNames, 18* (nbExtShip + 1));
				if (ptrNames == NULL) exit_proc(MEM_ERROR);
				strcpy(ptrNames + 18 * nbExtShip, fullName);
				nbExtShip++;
				}
			fclose(fp1);
  		}
  	SymPtr = SymFindNext();	
		}
		
	if (nbExtShip)
		{
		if (!(ptrNames = (char*) malloc(18*nbExtShip)))
			{
			FolderOp (NULL, FOP_ALL_FOLDERS | FOP_UNLOCK); // unlocker l'ensemble des fichiers de la calc
			exit_proc(MEM_ERROR);
			}
		
		i = 0;
		SymPtr = SymFindFirst (NULL, FO_RECURSE);
		while (SymPtr)
			{
  		if (SymPtr->flags.bits.folder != 1) // si la "variable" trouve n'est pas un dossier :
  			{
  			strcpy(folder, SymFindFolderName());	// enregistre le nom du dossier courant
  			strcpy(name, SymPtr->name); // enregistre le nom du fichier courant
  			sprintf(fullName, "%s\\%s", folder, name);
  		
  			fp1 = fopen(fullName,"rb");
  			fread(&code,sizeof(code),1,fp1);
  			fseek(fp1, -6, SEEK_END); // avancer jusqu'a la fin du fichier
  			fread(extBuf, 4, 1, fp1);	// lit l'extension
  			extBuf[4] = '\0';
  			if ((code == CODE_SHIP) && !strcmp("SHIP", extBuf))
 					{
					strcpy(ptrNames + 18 * i, fullName);
					i++;
					}
				fclose(fp1);
  			}
  		SymPtr = SymFindNext();	
			}
		}	

	FolderOp (NULL, FOP_ALL_FOLDERS | FOP_UNLOCK); // unlocker l'ensemble des fichiers de la calc
	
	*/